import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexMdbMongodbClusterConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#cluster_id DataYandexMdbMongodbCluster#cluster_id}
    */
    readonly clusterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#created_at DataYandexMdbMongodbCluster#created_at}
    */
    readonly createdAt?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#deletion_protection DataYandexMdbMongodbCluster#deletion_protection}
    */
    readonly deletionProtection?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#description DataYandexMdbMongodbCluster#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#environment DataYandexMdbMongodbCluster#environment}
    */
    readonly environment?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#folder_id DataYandexMdbMongodbCluster#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#health DataYandexMdbMongodbCluster#health}
    */
    readonly health?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#id DataYandexMdbMongodbCluster#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#labels DataYandexMdbMongodbCluster#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#name DataYandexMdbMongodbCluster#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#network_id DataYandexMdbMongodbCluster#network_id}
    */
    readonly networkId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#security_group_ids DataYandexMdbMongodbCluster#security_group_ids}
    */
    readonly securityGroupIds?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#sharded DataYandexMdbMongodbCluster#sharded}
    */
    readonly sharded?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#status DataYandexMdbMongodbCluster#status}
    */
    readonly status?: string;
    /**
    * cluster_config block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#cluster_config DataYandexMdbMongodbCluster#cluster_config}
    */
    readonly clusterConfig?: DataYandexMdbMongodbClusterClusterConfig;
    /**
    * database block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#database DataYandexMdbMongodbCluster#database}
    */
    readonly database?: DataYandexMdbMongodbClusterDatabase[] | cdktf.IResolvable;
    /**
    * host block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#host DataYandexMdbMongodbCluster#host}
    */
    readonly host?: DataYandexMdbMongodbClusterHost[] | cdktf.IResolvable;
    /**
    * maintenance_window block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#maintenance_window DataYandexMdbMongodbCluster#maintenance_window}
    */
    readonly maintenanceWindow?: DataYandexMdbMongodbClusterMaintenanceWindow;
    /**
    * resources block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#resources DataYandexMdbMongodbCluster#resources}
    */
    readonly resources?: DataYandexMdbMongodbClusterResources;
    /**
    * user block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#user DataYandexMdbMongodbCluster#user}
    */
    readonly user?: DataYandexMdbMongodbClusterUser[] | cdktf.IResolvable;
}
export interface DataYandexMdbMongodbClusterClusterConfigAccess {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#data_lens DataYandexMdbMongodbCluster#data_lens}
    */
    readonly dataLens?: boolean | cdktf.IResolvable;
}
export declare function dataYandexMdbMongodbClusterClusterConfigAccessToTerraform(struct?: DataYandexMdbMongodbClusterClusterConfigAccessOutputReference | DataYandexMdbMongodbClusterClusterConfigAccess): any;
export declare class DataYandexMdbMongodbClusterClusterConfigAccessOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexMdbMongodbClusterClusterConfigAccess | undefined;
    set internalValue(value: DataYandexMdbMongodbClusterClusterConfigAccess | undefined);
    private _dataLens?;
    get dataLens(): boolean | cdktf.IResolvable;
    set dataLens(value: boolean | cdktf.IResolvable);
    resetDataLens(): void;
    get dataLensInput(): boolean | cdktf.IResolvable | undefined;
}
export interface DataYandexMdbMongodbClusterClusterConfigBackupWindowStart {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#hours DataYandexMdbMongodbCluster#hours}
    */
    readonly hours?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#minutes DataYandexMdbMongodbCluster#minutes}
    */
    readonly minutes?: number;
}
export declare function dataYandexMdbMongodbClusterClusterConfigBackupWindowStartToTerraform(struct?: DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference | DataYandexMdbMongodbClusterClusterConfigBackupWindowStart): any;
export declare class DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexMdbMongodbClusterClusterConfigBackupWindowStart | undefined;
    set internalValue(value: DataYandexMdbMongodbClusterClusterConfigBackupWindowStart | undefined);
    private _hours?;
    get hours(): number;
    set hours(value: number);
    resetHours(): void;
    get hoursInput(): number | undefined;
    private _minutes?;
    get minutes(): number;
    set minutes(value: number);
    resetMinutes(): void;
    get minutesInput(): number | undefined;
}
export interface DataYandexMdbMongodbClusterClusterConfigMongodAuditLog {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#filter DataYandexMdbMongodbCluster#filter}
    */
    readonly filter?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#runtime_configuration DataYandexMdbMongodbCluster#runtime_configuration}
    */
    readonly runtimeConfiguration?: boolean | cdktf.IResolvable;
}
export declare function dataYandexMdbMongodbClusterClusterConfigMongodAuditLogToTerraform(struct?: DataYandexMdbMongodbClusterClusterConfigMongodAuditLogOutputReference | DataYandexMdbMongodbClusterClusterConfigMongodAuditLog): any;
export declare class DataYandexMdbMongodbClusterClusterConfigMongodAuditLogOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexMdbMongodbClusterClusterConfigMongodAuditLog | undefined;
    set internalValue(value: DataYandexMdbMongodbClusterClusterConfigMongodAuditLog | undefined);
    private _filter?;
    get filter(): string;
    set filter(value: string);
    resetFilter(): void;
    get filterInput(): string | undefined;
    private _runtimeConfiguration?;
    get runtimeConfiguration(): boolean | cdktf.IResolvable;
    set runtimeConfiguration(value: boolean | cdktf.IResolvable);
    resetRuntimeConfiguration(): void;
    get runtimeConfigurationInput(): boolean | cdktf.IResolvable | undefined;
}
export interface DataYandexMdbMongodbClusterClusterConfigMongodSecurityKmip {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#client_certificate DataYandexMdbMongodbCluster#client_certificate}
    */
    readonly clientCertificate?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#key_identifier DataYandexMdbMongodbCluster#key_identifier}
    */
    readonly keyIdentifier?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#port DataYandexMdbMongodbCluster#port}
    */
    readonly port?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#server_ca DataYandexMdbMongodbCluster#server_ca}
    */
    readonly serverCa?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#server_name DataYandexMdbMongodbCluster#server_name}
    */
    readonly serverName?: string;
}
export declare function dataYandexMdbMongodbClusterClusterConfigMongodSecurityKmipToTerraform(struct?: DataYandexMdbMongodbClusterClusterConfigMongodSecurityKmipOutputReference | DataYandexMdbMongodbClusterClusterConfigMongodSecurityKmip): any;
export declare class DataYandexMdbMongodbClusterClusterConfigMongodSecurityKmipOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexMdbMongodbClusterClusterConfigMongodSecurityKmip | undefined;
    set internalValue(value: DataYandexMdbMongodbClusterClusterConfigMongodSecurityKmip | undefined);
    private _clientCertificate?;
    get clientCertificate(): string;
    set clientCertificate(value: string);
    resetClientCertificate(): void;
    get clientCertificateInput(): string | undefined;
    private _keyIdentifier?;
    get keyIdentifier(): string;
    set keyIdentifier(value: string);
    resetKeyIdentifier(): void;
    get keyIdentifierInput(): string | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    resetPort(): void;
    get portInput(): number | undefined;
    private _serverCa?;
    get serverCa(): string;
    set serverCa(value: string);
    resetServerCa(): void;
    get serverCaInput(): string | undefined;
    private _serverName?;
    get serverName(): string;
    set serverName(value: string);
    resetServerName(): void;
    get serverNameInput(): string | undefined;
}
export interface DataYandexMdbMongodbClusterClusterConfigMongodSecurity {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#enable_encryption DataYandexMdbMongodbCluster#enable_encryption}
    */
    readonly enableEncryption?: boolean | cdktf.IResolvable;
    /**
    * kmip block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#kmip DataYandexMdbMongodbCluster#kmip}
    */
    readonly kmip?: DataYandexMdbMongodbClusterClusterConfigMongodSecurityKmip;
}
export declare function dataYandexMdbMongodbClusterClusterConfigMongodSecurityToTerraform(struct?: DataYandexMdbMongodbClusterClusterConfigMongodSecurityOutputReference | DataYandexMdbMongodbClusterClusterConfigMongodSecurity): any;
export declare class DataYandexMdbMongodbClusterClusterConfigMongodSecurityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexMdbMongodbClusterClusterConfigMongodSecurity | undefined;
    set internalValue(value: DataYandexMdbMongodbClusterClusterConfigMongodSecurity | undefined);
    private _enableEncryption?;
    get enableEncryption(): boolean | cdktf.IResolvable;
    set enableEncryption(value: boolean | cdktf.IResolvable);
    resetEnableEncryption(): void;
    get enableEncryptionInput(): boolean | cdktf.IResolvable | undefined;
    private _kmip;
    get kmip(): DataYandexMdbMongodbClusterClusterConfigMongodSecurityKmipOutputReference;
    putKmip(value: DataYandexMdbMongodbClusterClusterConfigMongodSecurityKmip): void;
    resetKmip(): void;
    get kmipInput(): DataYandexMdbMongodbClusterClusterConfigMongodSecurityKmip | undefined;
}
export interface DataYandexMdbMongodbClusterClusterConfigMongodSetParameter {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#audit_authorization_success DataYandexMdbMongodbCluster#audit_authorization_success}
    */
    readonly auditAuthorizationSuccess?: boolean | cdktf.IResolvable;
}
export declare function dataYandexMdbMongodbClusterClusterConfigMongodSetParameterToTerraform(struct?: DataYandexMdbMongodbClusterClusterConfigMongodSetParameterOutputReference | DataYandexMdbMongodbClusterClusterConfigMongodSetParameter): any;
export declare class DataYandexMdbMongodbClusterClusterConfigMongodSetParameterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexMdbMongodbClusterClusterConfigMongodSetParameter | undefined;
    set internalValue(value: DataYandexMdbMongodbClusterClusterConfigMongodSetParameter | undefined);
    private _auditAuthorizationSuccess?;
    get auditAuthorizationSuccess(): boolean | cdktf.IResolvable;
    set auditAuthorizationSuccess(value: boolean | cdktf.IResolvable);
    resetAuditAuthorizationSuccess(): void;
    get auditAuthorizationSuccessInput(): boolean | cdktf.IResolvable | undefined;
}
export interface DataYandexMdbMongodbClusterClusterConfigMongod {
    /**
    * audit_log block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#audit_log DataYandexMdbMongodbCluster#audit_log}
    */
    readonly auditLog?: DataYandexMdbMongodbClusterClusterConfigMongodAuditLog;
    /**
    * security block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#security DataYandexMdbMongodbCluster#security}
    */
    readonly security?: DataYandexMdbMongodbClusterClusterConfigMongodSecurity;
    /**
    * set_parameter block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#set_parameter DataYandexMdbMongodbCluster#set_parameter}
    */
    readonly setParameter?: DataYandexMdbMongodbClusterClusterConfigMongodSetParameter;
}
export declare function dataYandexMdbMongodbClusterClusterConfigMongodToTerraform(struct?: DataYandexMdbMongodbClusterClusterConfigMongodOutputReference | DataYandexMdbMongodbClusterClusterConfigMongod): any;
export declare class DataYandexMdbMongodbClusterClusterConfigMongodOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexMdbMongodbClusterClusterConfigMongod | undefined;
    set internalValue(value: DataYandexMdbMongodbClusterClusterConfigMongod | undefined);
    private _auditLog;
    get auditLog(): DataYandexMdbMongodbClusterClusterConfigMongodAuditLogOutputReference;
    putAuditLog(value: DataYandexMdbMongodbClusterClusterConfigMongodAuditLog): void;
    resetAuditLog(): void;
    get auditLogInput(): DataYandexMdbMongodbClusterClusterConfigMongodAuditLog | undefined;
    private _security;
    get security(): DataYandexMdbMongodbClusterClusterConfigMongodSecurityOutputReference;
    putSecurity(value: DataYandexMdbMongodbClusterClusterConfigMongodSecurity): void;
    resetSecurity(): void;
    get securityInput(): DataYandexMdbMongodbClusterClusterConfigMongodSecurity | undefined;
    private _setParameter;
    get setParameter(): DataYandexMdbMongodbClusterClusterConfigMongodSetParameterOutputReference;
    putSetParameter(value: DataYandexMdbMongodbClusterClusterConfigMongodSetParameter): void;
    resetSetParameter(): void;
    get setParameterInput(): DataYandexMdbMongodbClusterClusterConfigMongodSetParameter | undefined;
}
export interface DataYandexMdbMongodbClusterClusterConfig {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#feature_compatibility_version DataYandexMdbMongodbCluster#feature_compatibility_version}
    */
    readonly featureCompatibilityVersion?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#version DataYandexMdbMongodbCluster#version}
    */
    readonly version?: string;
    /**
    * access block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#access DataYandexMdbMongodbCluster#access}
    */
    readonly access?: DataYandexMdbMongodbClusterClusterConfigAccess;
    /**
    * backup_window_start block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#backup_window_start DataYandexMdbMongodbCluster#backup_window_start}
    */
    readonly backupWindowStart?: DataYandexMdbMongodbClusterClusterConfigBackupWindowStart;
    /**
    * mongod block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#mongod DataYandexMdbMongodbCluster#mongod}
    */
    readonly mongod?: DataYandexMdbMongodbClusterClusterConfigMongod;
}
export declare function dataYandexMdbMongodbClusterClusterConfigToTerraform(struct?: DataYandexMdbMongodbClusterClusterConfigOutputReference | DataYandexMdbMongodbClusterClusterConfig): any;
export declare class DataYandexMdbMongodbClusterClusterConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexMdbMongodbClusterClusterConfig | undefined;
    set internalValue(value: DataYandexMdbMongodbClusterClusterConfig | undefined);
    private _featureCompatibilityVersion?;
    get featureCompatibilityVersion(): string;
    set featureCompatibilityVersion(value: string);
    resetFeatureCompatibilityVersion(): void;
    get featureCompatibilityVersionInput(): string | undefined;
    private _version?;
    get version(): string;
    set version(value: string);
    resetVersion(): void;
    get versionInput(): string | undefined;
    private _access;
    get access(): DataYandexMdbMongodbClusterClusterConfigAccessOutputReference;
    putAccess(value: DataYandexMdbMongodbClusterClusterConfigAccess): void;
    resetAccess(): void;
    get accessInput(): DataYandexMdbMongodbClusterClusterConfigAccess | undefined;
    private _backupWindowStart;
    get backupWindowStart(): DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference;
    putBackupWindowStart(value: DataYandexMdbMongodbClusterClusterConfigBackupWindowStart): void;
    resetBackupWindowStart(): void;
    get backupWindowStartInput(): DataYandexMdbMongodbClusterClusterConfigBackupWindowStart | undefined;
    private _mongod;
    get mongod(): DataYandexMdbMongodbClusterClusterConfigMongodOutputReference;
    putMongod(value: DataYandexMdbMongodbClusterClusterConfigMongod): void;
    resetMongod(): void;
    get mongodInput(): DataYandexMdbMongodbClusterClusterConfigMongod | undefined;
}
export interface DataYandexMdbMongodbClusterDatabase {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#name DataYandexMdbMongodbCluster#name}
    */
    readonly name?: string;
}
export declare function dataYandexMdbMongodbClusterDatabaseToTerraform(struct?: DataYandexMdbMongodbClusterDatabase | cdktf.IResolvable): any;
export declare class DataYandexMdbMongodbClusterDatabaseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbMongodbClusterDatabase | cdktf.IResolvable | undefined;
    set internalValue(value: DataYandexMdbMongodbClusterDatabase | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export declare class DataYandexMdbMongodbClusterDatabaseList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataYandexMdbMongodbClusterDatabase[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbMongodbClusterDatabaseOutputReference;
}
export interface DataYandexMdbMongodbClusterHost {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#assign_public_ip DataYandexMdbMongodbCluster#assign_public_ip}
    */
    readonly assignPublicIp?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#health DataYandexMdbMongodbCluster#health}
    */
    readonly health?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#name DataYandexMdbMongodbCluster#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#role DataYandexMdbMongodbCluster#role}
    */
    readonly role?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#shard_name DataYandexMdbMongodbCluster#shard_name}
    */
    readonly shardName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#subnet_id DataYandexMdbMongodbCluster#subnet_id}
    */
    readonly subnetId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#type DataYandexMdbMongodbCluster#type}
    */
    readonly type?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#zone_id DataYandexMdbMongodbCluster#zone_id}
    */
    readonly zoneId?: string;
}
export declare function dataYandexMdbMongodbClusterHostToTerraform(struct?: DataYandexMdbMongodbClusterHost | cdktf.IResolvable): any;
export declare class DataYandexMdbMongodbClusterHostOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbMongodbClusterHost | cdktf.IResolvable | undefined;
    set internalValue(value: DataYandexMdbMongodbClusterHost | cdktf.IResolvable | undefined);
    private _assignPublicIp?;
    get assignPublicIp(): boolean | cdktf.IResolvable;
    set assignPublicIp(value: boolean | cdktf.IResolvable);
    resetAssignPublicIp(): void;
    get assignPublicIpInput(): boolean | cdktf.IResolvable | undefined;
    private _health?;
    get health(): string;
    set health(value: string);
    resetHealth(): void;
    get healthInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _role?;
    get role(): string;
    set role(value: string);
    resetRole(): void;
    get roleInput(): string | undefined;
    private _shardName?;
    get shardName(): string;
    set shardName(value: string);
    resetShardName(): void;
    get shardNameInput(): string | undefined;
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    resetSubnetId(): void;
    get subnetIdInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _zoneId?;
    get zoneId(): string;
    set zoneId(value: string);
    resetZoneId(): void;
    get zoneIdInput(): string | undefined;
}
export declare class DataYandexMdbMongodbClusterHostList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataYandexMdbMongodbClusterHost[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbMongodbClusterHostOutputReference;
}
export interface DataYandexMdbMongodbClusterMaintenanceWindow {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#day DataYandexMdbMongodbCluster#day}
    */
    readonly day?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#hour DataYandexMdbMongodbCluster#hour}
    */
    readonly hour?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#type DataYandexMdbMongodbCluster#type}
    */
    readonly type?: string;
}
export declare function dataYandexMdbMongodbClusterMaintenanceWindowToTerraform(struct?: DataYandexMdbMongodbClusterMaintenanceWindowOutputReference | DataYandexMdbMongodbClusterMaintenanceWindow): any;
export declare class DataYandexMdbMongodbClusterMaintenanceWindowOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexMdbMongodbClusterMaintenanceWindow | undefined;
    set internalValue(value: DataYandexMdbMongodbClusterMaintenanceWindow | undefined);
    private _day?;
    get day(): string;
    set day(value: string);
    resetDay(): void;
    get dayInput(): string | undefined;
    private _hour?;
    get hour(): number;
    set hour(value: number);
    resetHour(): void;
    get hourInput(): number | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
}
export interface DataYandexMdbMongodbClusterResources {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#disk_size DataYandexMdbMongodbCluster#disk_size}
    */
    readonly diskSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#disk_type_id DataYandexMdbMongodbCluster#disk_type_id}
    */
    readonly diskTypeId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#resource_preset_id DataYandexMdbMongodbCluster#resource_preset_id}
    */
    readonly resourcePresetId?: string;
}
export declare function dataYandexMdbMongodbClusterResourcesToTerraform(struct?: DataYandexMdbMongodbClusterResourcesOutputReference | DataYandexMdbMongodbClusterResources): any;
export declare class DataYandexMdbMongodbClusterResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexMdbMongodbClusterResources | undefined;
    set internalValue(value: DataYandexMdbMongodbClusterResources | undefined);
    private _diskSize?;
    get diskSize(): number;
    set diskSize(value: number);
    resetDiskSize(): void;
    get diskSizeInput(): number | undefined;
    private _diskTypeId?;
    get diskTypeId(): string;
    set diskTypeId(value: string);
    resetDiskTypeId(): void;
    get diskTypeIdInput(): string | undefined;
    private _resourcePresetId?;
    get resourcePresetId(): string;
    set resourcePresetId(value: string);
    resetResourcePresetId(): void;
    get resourcePresetIdInput(): string | undefined;
}
export interface DataYandexMdbMongodbClusterUserPermission {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#database_name DataYandexMdbMongodbCluster#database_name}
    */
    readonly databaseName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#roles DataYandexMdbMongodbCluster#roles}
    */
    readonly roles?: string[];
}
export declare function dataYandexMdbMongodbClusterUserPermissionToTerraform(struct?: DataYandexMdbMongodbClusterUserPermission | cdktf.IResolvable): any;
export declare class DataYandexMdbMongodbClusterUserPermissionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbMongodbClusterUserPermission | cdktf.IResolvable | undefined;
    set internalValue(value: DataYandexMdbMongodbClusterUserPermission | cdktf.IResolvable | undefined);
    private _databaseName?;
    get databaseName(): string;
    set databaseName(value: string);
    resetDatabaseName(): void;
    get databaseNameInput(): string | undefined;
    private _roles?;
    get roles(): string[];
    set roles(value: string[]);
    resetRoles(): void;
    get rolesInput(): string[] | undefined;
}
export declare class DataYandexMdbMongodbClusterUserPermissionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataYandexMdbMongodbClusterUserPermission[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbMongodbClusterUserPermissionOutputReference;
}
export interface DataYandexMdbMongodbClusterUser {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#name DataYandexMdbMongodbCluster#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#password DataYandexMdbMongodbCluster#password}
    */
    readonly password?: string;
    /**
    * permission block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#permission DataYandexMdbMongodbCluster#permission}
    */
    readonly permission?: DataYandexMdbMongodbClusterUserPermission[] | cdktf.IResolvable;
}
export declare function dataYandexMdbMongodbClusterUserToTerraform(struct?: DataYandexMdbMongodbClusterUser | cdktf.IResolvable): any;
export declare class DataYandexMdbMongodbClusterUserOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbMongodbClusterUser | cdktf.IResolvable | undefined;
    set internalValue(value: DataYandexMdbMongodbClusterUser | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _password?;
    get password(): string;
    set password(value: string);
    resetPassword(): void;
    get passwordInput(): string | undefined;
    private _permission;
    get permission(): DataYandexMdbMongodbClusterUserPermissionList;
    putPermission(value: DataYandexMdbMongodbClusterUserPermission[] | cdktf.IResolvable): void;
    resetPermission(): void;
    get permissionInput(): cdktf.IResolvable | DataYandexMdbMongodbClusterUserPermission[] | undefined;
}
export declare class DataYandexMdbMongodbClusterUserList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataYandexMdbMongodbClusterUser[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbMongodbClusterUserOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster yandex_mdb_mongodb_cluster}
*/
export declare class DataYandexMdbMongodbCluster extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_mdb_mongodb_cluster";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster yandex_mdb_mongodb_cluster} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexMdbMongodbClusterConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexMdbMongodbClusterConfig);
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    resetClusterId(): void;
    get clusterIdInput(): string | undefined;
    private _createdAt?;
    get createdAt(): string;
    set createdAt(value: string);
    resetCreatedAt(): void;
    get createdAtInput(): string | undefined;
    private _deletionProtection?;
    get deletionProtection(): boolean | cdktf.IResolvable;
    set deletionProtection(value: boolean | cdktf.IResolvable);
    resetDeletionProtection(): void;
    get deletionProtectionInput(): boolean | cdktf.IResolvable | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _environment?;
    get environment(): string;
    set environment(value: string);
    resetEnvironment(): void;
    get environmentInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _health?;
    get health(): string;
    set health(value: string);
    resetHealth(): void;
    get healthInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _networkId?;
    get networkId(): string;
    set networkId(value: string);
    resetNetworkId(): void;
    get networkIdInput(): string | undefined;
    private _securityGroupIds?;
    get securityGroupIds(): string[];
    set securityGroupIds(value: string[]);
    resetSecurityGroupIds(): void;
    get securityGroupIdsInput(): string[] | undefined;
    private _sharded?;
    get sharded(): boolean | cdktf.IResolvable;
    set sharded(value: boolean | cdktf.IResolvable);
    resetSharded(): void;
    get shardedInput(): boolean | cdktf.IResolvable | undefined;
    private _status?;
    get status(): string;
    set status(value: string);
    resetStatus(): void;
    get statusInput(): string | undefined;
    private _clusterConfig;
    get clusterConfig(): DataYandexMdbMongodbClusterClusterConfigOutputReference;
    putClusterConfig(value: DataYandexMdbMongodbClusterClusterConfig): void;
    resetClusterConfig(): void;
    get clusterConfigInput(): DataYandexMdbMongodbClusterClusterConfig | undefined;
    private _database;
    get database(): DataYandexMdbMongodbClusterDatabaseList;
    putDatabase(value: DataYandexMdbMongodbClusterDatabase[] | cdktf.IResolvable): void;
    resetDatabase(): void;
    get databaseInput(): cdktf.IResolvable | DataYandexMdbMongodbClusterDatabase[] | undefined;
    private _host;
    get host(): DataYandexMdbMongodbClusterHostList;
    putHost(value: DataYandexMdbMongodbClusterHost[] | cdktf.IResolvable): void;
    resetHost(): void;
    get hostInput(): cdktf.IResolvable | DataYandexMdbMongodbClusterHost[] | undefined;
    private _maintenanceWindow;
    get maintenanceWindow(): DataYandexMdbMongodbClusterMaintenanceWindowOutputReference;
    putMaintenanceWindow(value: DataYandexMdbMongodbClusterMaintenanceWindow): void;
    resetMaintenanceWindow(): void;
    get maintenanceWindowInput(): DataYandexMdbMongodbClusterMaintenanceWindow | undefined;
    private _resources;
    get resources(): DataYandexMdbMongodbClusterResourcesOutputReference;
    putResources(value: DataYandexMdbMongodbClusterResources): void;
    resetResources(): void;
    get resourcesInput(): DataYandexMdbMongodbClusterResources | undefined;
    private _user;
    get user(): DataYandexMdbMongodbClusterUserList;
    putUser(value: DataYandexMdbMongodbClusterUser[] | cdktf.IResolvable): void;
    resetUser(): void;
    get userInput(): cdktf.IResolvable | DataYandexMdbMongodbClusterUser[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
