import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexMdbPostgresqlDatabaseConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_database#cluster_id DataYandexMdbPostgresqlDatabase#cluster_id}
    */
    readonly clusterId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_database#id DataYandexMdbPostgresqlDatabase#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_database#lc_collate DataYandexMdbPostgresqlDatabase#lc_collate}
    */
    readonly lcCollate?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_database#lc_type DataYandexMdbPostgresqlDatabase#lc_type}
    */
    readonly lcType?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_database#name DataYandexMdbPostgresqlDatabase#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_database#owner DataYandexMdbPostgresqlDatabase#owner}
    */
    readonly owner?: string;
    /**
    * extension block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_database#extension DataYandexMdbPostgresqlDatabase#extension}
    */
    readonly extension?: DataYandexMdbPostgresqlDatabaseExtension[] | cdktf.IResolvable;
}
export interface DataYandexMdbPostgresqlDatabaseExtension {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_database#name DataYandexMdbPostgresqlDatabase#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_database#version DataYandexMdbPostgresqlDatabase#version}
    */
    readonly version?: string;
}
export declare function dataYandexMdbPostgresqlDatabaseExtensionToTerraform(struct?: DataYandexMdbPostgresqlDatabaseExtension | cdktf.IResolvable): any;
export declare class DataYandexMdbPostgresqlDatabaseExtensionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbPostgresqlDatabaseExtension | cdktf.IResolvable | undefined;
    set internalValue(value: DataYandexMdbPostgresqlDatabaseExtension | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _version?;
    get version(): string;
    set version(value: string);
    resetVersion(): void;
    get versionInput(): string | undefined;
}
export declare class DataYandexMdbPostgresqlDatabaseExtensionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataYandexMdbPostgresqlDatabaseExtension[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbPostgresqlDatabaseExtensionOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_database yandex_mdb_postgresql_database}
*/
export declare class DataYandexMdbPostgresqlDatabase extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_mdb_postgresql_database";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_database yandex_mdb_postgresql_database} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexMdbPostgresqlDatabaseConfig
    */
    constructor(scope: Construct, id: string, config: DataYandexMdbPostgresqlDatabaseConfig);
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    get clusterIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _lcCollate?;
    get lcCollate(): string;
    set lcCollate(value: string);
    resetLcCollate(): void;
    get lcCollateInput(): string | undefined;
    private _lcType?;
    get lcType(): string;
    set lcType(value: string);
    resetLcType(): void;
    get lcTypeInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _owner?;
    get owner(): string;
    set owner(value: string);
    resetOwner(): void;
    get ownerInput(): string | undefined;
    private _extension;
    get extension(): DataYandexMdbPostgresqlDatabaseExtensionList;
    putExtension(value: DataYandexMdbPostgresqlDatabaseExtension[] | cdktf.IResolvable): void;
    resetExtension(): void;
    get extensionInput(): cdktf.IResolvable | DataYandexMdbPostgresqlDatabaseExtension[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
